; Dunjunz - Games Master Edition
; Copyright (c) 2017-2020 Ciaran Anscomb
;
; See COPYING file for redistribution conditions.

; ========================================================================

                include "dragonhw.s"
                include "games-master.s"
                include "defs.s"
                include "macros.s"

                include "bank0a.exp"

; ========================================================================

		org $c000

		export play_song
		export reset_song

song_loop

		; song
		dec p_timer
		bne 20F
		ldu song_ptr
		cmpu #song_end
		blo 10F
		ldu #song_repeat
10		lda #96		; fixed pattern size
		sta p_timer
		pulu x,y
		lda ,x+
		ldb ,y+
		std c1_a_timer
		stx c1_a_next
		sty c1_f_next
		pulu x,y
		lda ,x+
		ldb ,y+
		std c2_a_timer
		stx c2_a_next
		sty c2_f_next
		pulu x,y
		lda ,x+
		ldb ,y+
		std c3_a_timer
		stx c3_a_next
		sty c3_f_next
		stu song_ptr
20

		; channel 1
		dec c1_a_timer
		bne 10F
		ldu c1_a_next
		pulu a,b
		sta c1_a_timer
		orb #$90
		stb reg_gmc_snd
		stb psg_c1att
		stu c1_a_next
10		dec c1_f_timer
		bne 20F
		ldu c1_f_next
		pulu a
		sta c1_f_timer
		pulu a
		ora #$80
		sta reg_gmc_snd
		pulu a
		sta reg_gmc_snd
		stu c1_f_next
20

		; channel 2
		dec c2_a_timer
		bne 10F
		ldu c2_a_next
		pulu a,b
		sta c2_a_timer
		orb #$b0
		stb reg_gmc_snd
		stb psg_c2att
		stu c2_a_next
10		dec c2_f_timer
		bne 20F
		ldu c2_f_next
		pulu a
		sta c2_f_timer
		pulu a
		ora #$a0
		sta reg_gmc_snd
		pulu a
		sta reg_gmc_snd
		stu c2_f_next
20

		; channel 3
		dec c3_a_timer
		bne 10F
		ldu c3_a_next
		pulu a,b
		sta c3_a_timer
		orb #$f0
		stb reg_gmc_snd
		stb psg_c3att
		stu c3_a_next
10		dec c3_f_timer
		bne 20F
		ldu c3_f_next
		pulu a
		sta c3_f_timer
		pulu a
		ora #$c0
		sta reg_gmc_snd
		pulu a
		sta reg_gmc_snd
		stu c3_f_next
20

		ldx #1117	; 10ms
10		leax -1,x
		bne 10B

		lda reg_pia0_pdra
		ora #$80
		inca
		lbeq song_loop

		lda #15
		pshs a
10		ldx #psg_c1att
		bsr fade_channel
		bsr fade_channel
		bsr fade_channel
		ldx #1678	; 15ms
20		leax -1,x
		bne 20B
		dec ,s
		bne 10B

		puls a,pc

fade_channel	ldb ,x+
		incb
		bitb #$0f
		beq 10F
		stb reg_gmc_snd
		stb -1,x
10		rts

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

play_song

		; wait if key held
		clr reg_pia0_pdrb
10		lda reg_pia0_pdra
		ora #$80
		inca
		bne 10B
		; leave set to detect any key

		lda #$e3	; periodic noise, tone3 rate
		sta reg_gmc_snd

		ldb #$3d
		stb reg_pia0_crb	; enable sound mux

		jmp song_loop

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

reset_song
		lda #1
		sta >p_timer
		ldu #song
		stu >song_ptr
		; mute all 76489 channels
		lda #$9f
		sta reg_gmc_snd
		sta >psg_c1att
		lda #$bf
		sta reg_gmc_snd
		sta >psg_c2att
		lda #$df
		sta reg_gmc_snd
		mul
		lda #$ff
		sta reg_gmc_snd
		sta >psg_c3att
		rts

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		export title_bin_dz
title_bin_dz	includebin "title.bin.dz"

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

		include "gsong.s"

; ========================================================================

		export play_screen_pal_dz,text_screen_pal_dz
		export play_screen_ntsc_dz,text_screen_ntsc_dz

play_screen_pal_dz	includebin "play-screen-pal.bin.dz"
text_screen_pal_dz	includebin "text-screen-pal.bin.dz"
play_screen_ntsc_dz	includebin "play-screen-ntsc.bin.dz"
text_screen_ntsc_dz	includebin "text-screen-ntsc.bin.dz"

; ========================================================================

		export death_screen,end_screen
		export credits_screen,credits_screen2
		export text_logo
		export text_p1_name,text_p2_name,text_p3_name,text_p4_name
		export text_p3_controls,text_p4_controls
		export text_p1_controls_coco,text_p2_controls_coco
		export text_brackets,text_skill,text_easy,text_hard
		export text_vmode,text_pal,text_ntsc0,text_ntsc1
		export text_cc3_cmp,text_cc3_rgb
		export text_to_play,text_space
		export press_key

		include "text.s"

; ========================================================================

bank3_end

		align $4000,$ff

